package ausgabeapplet;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.applet.Applet;
import java.awt.Graphics;
import java.util.Vector;
import java.sql.*;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (C)J.M.Joller
 * @author J.M.Joller
 * @version 1.0
 */

public class JDBCAusgabeApplet extends Applet implements Runnable {
    private Thread worker;
    private Vector queryResults;
    private String message = "Initialisierung";

    public synchronized void start() {
	// miit start wird eine neue Abfrage gestartet
	// also die DB abgefragt
	if (worker == null) {
	    message = "Verbindungsaufbau zur Datenbank";
            worker = new Thread(this);
	    worker.start();
	}
    }

    /**
     * run startet den Worker Thread
     * Dieser fragt evtl die DB ab und das kann dauern
     * Aber es tritt kein Zugriffskonflikt auf / kein sync.
     */

    public void run() {
	String url = "jdbc:odbc:coffeebreak";
	String query = "select COF_NAME, PRICE from COFFEES";

	try {
	    Class.forName ("sun.jdbc.odbc.JdbcOdbcDriver");
	} catch(Exception ex) {
	    setError("Laden des Datenbank Treibers schlug fehl: " + ex);
	    return;
	}

	try {
	    Vector results = new Vector();
	    Connection con = DriverManager.getConnection(url,"myLogin", "myPassword");
	    Statement stmt = con.createStatement();
	    ResultSet rs = stmt.executeQuery(query);
	    while (rs.next()) {
		String s = rs.getString("COF_NAME");
		float f = rs.getFloat("PRICE");
		String text = s + "     " + f;
		results.addElement(text);
	    }

	    stmt.close();
	    con.close();

	    setResults(results);

	} catch(SQLException ex) {
	    setError("SQLException: " + ex);
	}
    }

    /**
     * paint muss das Ergebnis anzeigen
     * hoffentlich
     */

    public synchronized void paint(Graphics g) {
	// liegt ein Ergebnis vor?
	if (queryResults == null) {
	    g.drawString(message, 5, 50);
	    return;
	}

	// Display the results.
        g.drawString("",5,10);
	g.drawString("Kaffee Preis pro Pfund:  ", 15, 20);
	int y = 30;
	java.util.Enumeration enum = queryResults.elements();
	while (enum.hasMoreElements()) {
	    String text = (String)enum.nextElement();
	    g.drawString(text, 15, y+15);
	    y = y + 15;
	}
    }

    /**
     * zwischenspeichern einer Fehlermeldung
     * Diese wird spter angezeigt.
     */

    private synchronized void setError(String mess) {
	queryResults = null;
	message = mess;
	worker = null;
	// Anzeige
	repaint();
    }

    /**
     * Ergebnisse der Abfrage abspeichern
     * Angezeigt wird spter
     */

    private synchronized void setResults(Vector results) {
	queryResults = results;
	worker = null;
	// AWT soll anzeigen
	repaint();
    }
}
