package flugreservation;

import java.rmi.*;
import java.rmi.server.*;
/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:      Joller-Voss GmbH
 * @author J.M.Joller
 * @version 1.0
 */

public class Kunde_Impl extends UnicastRemoteObject implements Kunde {

	private Datenbank db = null;

	// Konstruktor
	public Kunde_Impl(Datenbank db) throws RemoteException {
		this.db = db;
	}

	// Kundenrecord
	public KundenInfo liesKundenInfo(String kundenID) throws RemoteException {
		KundenInfo kunde = null;
		try {
			kunde = db.liesKunde(kundenID);
		} catch(RecordNotFoundException e) {
			System.err.println("liesKunde Exception : "+e);
		}
		return kunde;
	}

	// Liste der mglichen Kunden (Vorname, Name)
	public KundenInfo[ ] liesKundenInfo(String vorName, String nachName) throws RemoteException {
		KundenInfo[ ] kunde = null;
		try {
			kunde = db.liesKunde(vorName, nachName);
		} catch(Exception e) {
			System.err.println("liesKundenInfo(array) Exception: "+e);
		}
		return kunde;
	}

	// Eintrag eines Kundenrecords in die Kundentabelle
	public void neueKundenInfo(String id, String nachName, String vorName, String strassenAdresse) throws RemoteException {
		try {
			db.neuerKunde(id, nachName, vorName, strassenAdresse);
		} catch(InvalidTransactionException e) {
			System.err.println("neuerKunde Exception : "+e);
		} catch(DuplicateIDException e) {
			System.err.println("neuerKunde Exception : "+e);
		}
	}

	public void bestehendeKundenInfo(String id, String nachName, String vorName, String strassenAdresse) throws RemoteException {
		try {
			db.bestehenderKunde(id, nachName, vorName, strassenAdresse);
		} catch(RecordNotFoundException e) {
			System.err.println("bestehendeKundenInfo Exception : "+e);
		}
	}

	// produziere eine neue Customer ID, mittels einer Formel, die nur ein Programmierer kenen kann
	public String produziereID(String nachName, String vorName) throws RemoteException {
		char EN = Character.toUpperCase(vorName.charAt(0) );
		char LN = Character.toUpperCase(nachName.charAt(0) );
		int ID = (int)(Math.random()*100000);
		String kundenID = new String(
 			new StringBuffer().append(EN).append(LN).append(Integer.toString(ID) ));
		return kundenID;
	}

	// KundenInfo Objekt als String
	public String produziereKundenString(KundenInfo info) throws RemoteException {
		String KundenString = info.kundenID + "-" + info.nachName + "-"
					+ info.vorName + "-" + info.strassenAdresse;
		return KundenString;
	}
}
