package flugreservation;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:      Joller-Voss GmbH
 * @author J.M.Joller
 * @version 1.0
 */
import java.sql.*;
import java.util.*;
// import imaginary.sql.*; // fiktiver Treiber,

public class Abfrage {
  public static void main (String args[]) {
    if (args.length < 1) {
      System.out.println ("Usage:");
      System.out.println ("java Abfrage <db>");
      System.exit (1);
    }
    try {
      // Instanz des (fiktiven) iMsqlDrivers bilden (mySQL z.B.)
      //new imaginary.sql.iMsqlDriver ();
      // das ist der ODBC Driver
      Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
      // Definition der "url"
      //String url = "jdbc:msql://" + args[0] + ":1112/FlugreservationsDB";
      String url = "jdbc:odbc:FlugreservationsDB";

      // fakultatives Registrieren (wird implizit gemacht)
      Driver drv = DriverManager.getDriver(url);
      DriverManager.registerDriver(drv);
      for (Enumeration drvs = DriverManager.getDrivers(); drvs.hasMoreElements(); )
        System.out.println(drvs.nextElement().getClass());


      if (args.length > 0) url = "jdbc:odbc:"+args[0];
      // Verbindungsaufbau mit Hilfe des DriverManager
      Connection conn = DriverManager.getConnection (url);
      // kreieren eines Statement Objekts
      Statement stmt = conn.createStatement ();
      // Query ausfhren (mit dem Statement Objekt)
      // und Definition des ResultSet Objekts
      ResultSet rs = stmt.executeQuery ("SELECT * from FlugzeugTyp");
      // Ausgabe der Ergebnisse - Zeile fr Zeile
      while (rs.next()) {
        System.out.println ("");
        System.out.println ("Flugzeugtyp:          \t" + rs.getString (1));
        System.out.println ("First Class Pltze:   \t" + rs.getInt (2));
        System.out.println ("Business Class Pltze:\t" + rs.getInt (3));
        System.out.println ("Economy Class Pltze: \t" + rs.getInt (4));
      }
    } catch (ClassNotFoundException ex) {
      System.err.println("ODBC Treiber wurde nicht gefunden");
    } catch (SQLException e) {
      e.printStackTrace();
    }
  }
}
