package flugreservation;

/**
 * Title:
 * Description: Das Interface beschreibt die bentigten Methoden fr unser
 *              Flugreservationsbeispiel
 * Copyright:    Copyright (c) 2000
 * Company:      Joller-Voss GmbH
 * @author J.M.Joller
 * @version 1.0
 */

public interface Fluege {

   /**
    * Die Methode bestimmeAlleAbflughaefen liefert alle Abflughfen als Array
    */
   String [] bestimmeAlleAbflughaefen();

   /**
    * Die Methode bestimmeAlleZielflughaefen() liefert alle Zielflughfen als Array
    */
   String [] bestimmeAlleZielflughaefen();

  /**
   * Die Methode bestimmeAlleFluege liefert alle Flge
   * am Datum date
   * vom Flughafen origin
   * zum Flughafen dest
   */
   FlugInfo[] bestimmeAlleFluege(String origin, String dest, String date);

  /**
   * Die Methode produceFlightString generiert eine eindeutige Zeichenkette
   * fr alle Flge
   */
   String produziereFlugString (FlugInfo flugObjekt);
}