package flugreservation;
import java.sql.*;
import java.util.*;

/**
 * Title:
 * Description:  Fragment!!!!!!!!
 * Copyright:    Copyright (c) 2000
 * Company:      Joller-Voss GmbH
 * @author J.M.Joller
 * @version 1.0
 */

public class FluegeImpl implements Fluege {
  Connection mSQLcon = null;

  /**
   * FluegeImpl schafft als erstes eine Verbindung zur Datenbank.
   * Der Datenbank-Server wird als Parameter dem Konstruktor
   * mitgegeben.
   */
  public FluegeImpl{String ServerName) {
    String url = " jdbc:odbc://"+ServerName + ":1112/FlugreservationsDB";

    try {
      mSQLcon = DriverManager.getConnection(url);
    } catch(java.sql.SQLException SQLEx) {
      System.out.println(SQLEx.getMessage() );
      SQLEx.printStackTrace();
      System.out.println("Die Datenbank antwortet nicht");
    }
  }

  /**
   * Die Methode bestimmeAlleAbflughaefen liefert alle Abflughfen als Array
   */
  public String [] bestimmeAlleAbflughaefen(){
    // Statement Objekt ist der Gateway zur Datenbank
    Statement Origins = null;
    Vector OrigStaedteV = new Vector(10, 10);
    String [] OrigStaedte = null;
    ResultSet rs = null;
    int j = 0;

    /* mit DISTINCT werden alle Datenstze nur einmal angezeigt
     */

    try {
      Origins = mSQLcon.createStatement();
      System.out.println (Origins);
      Rs = Origins.executeQuery("SELECT DISTINCT originCity FROM Fluege");
    } catch (java.sql.SQLException SQLEx){
      System.out.println(SQLEx.getMessage());
    }

    try {
      System.out.println(rs);
      while (rs.next()){
        OrigStaedteV.addElement(rs.getString(1));
      }
      rs.close();		// Resultset
    } catch (java.sql.SQLException SQLEx){
      System.out.println("Diese Spalte gibtes nicht");
    }

    OrigStaedte = new String[OrigStaedteV.size()];
    Enumeration OE = OrigStaedteV.elements();
    while(OE.hasMoreElements()){
      OrigStaedte[j] = (String)OE.nextElement();
      j++;
    }
    return OrigStaedte;
  }

  /**
   * Die Methode bestimmeAlleZielflughaefen() liefert alle Zielflughfen als Array
   */
  public String [] bestimmeAlleZielflughaefen(){
    String [] DestStaedte = null;
    Vector destStaedteV = new Vector(10, 10);
    Statement Destinationen = null;
    ResultSet rs = null;
    int j = 0;

    /* festlegen eines SQL Statements
       Abfragen mit DISTINCT Keyword garantiert, dass jedes Record / jeder Datensatz
       nur einmal angezeigt wird.
    */

    try {
      Destinationen = mSQLcon.createStatement();
      rs = Destinationen.executeQuery("SELECT DISTINCT destStadt FROM Fluege");
    } catch (java.sql.SQLException SQLEx){
      System.out.println(SQLEx.getMessage());
    }

    try {
      DestStaedte = new String[rs.getMetaData().getColumnCount()];
      while (rs.next()){
        destStaedteV.addElement(rs.getString(1));
      }
      rs.close();		// Result Set schliessen
    } catch (java.sql.SQLException SQLEx){
      System.out.println("Spalte mit diesem Namen gibts nicht in der Datenbank-Tabelle");
    }

    DestStaedte = new String[destStaedteV.size()];
    Enumeration OE = destStaedteV.elements();
    while(OE.hasMoreElements()){
      DestStaedte[j] = (String)OE.nextElement();
      j++;
    }
    System.out.println(DestStaedte[0]+"   "+DestStaedte[1]);
    return DestStaedte;
  }

  /**
   * Die Methode bestimmeAlleFluege liefert alle Flge
   * am Datum date
   * vom Flughafen origin
   * zum Flughafen dest
   */
   public FlugInfo[] bestimmeAlleFluege(String origin, String dest, String date){
    Statement verfuegbareFluege = null;
    ResultSet rs = null;
    Vector verfuegbarVec = new Vector(5, 3);
    Enumeration verfuegbarE = null;
    FlugInfo [] flugTag = null;
    int i = 0;

    try {
      verfuegbareFluege = mSQLcon.createStatement();
      // Datum konversion
      String wochentag = DateConverter.getDayOfWeek(date);
      rs = verfuegbareFluege.executeQuery
              ("SELECT * FROM Fluege WHERE originCity = '"+ origin +
              "' AND destCity = '" + dest+ "' AND departDate LIKE '%"+ wochentag +
              "%'ORDER BY flightNumber, originCity, destCity,departDate, departTime, planeID DESC ");

      /* nun haben wir die DB abgefragt und mssen das ResultSet bearbeiten
      */
      while (rs.next()){
        verfuegbarVec.addElement(new FlugInfo(rs.getString(1), rs.getString(2),
	rs.getString(3), date, rs.getString(5), rs.getString(6)));
      }
      rs.close();		// Resultset
    } catch (java.sql.SQLException SQLEx){
      System.out.println(SQLEx.getMessage());
    }
    flugTag = new FlugInfo[verfuegbarVec.size()];
    verfuegbarE = verfuegbarVec.elements();

    while(verfuegbarE.hasMoreElements()){
      flugTag[i] = (FlugInfo)verfuegbarE.nextElement();
      i++;
    }
    System.out.println(flugTag);
    return flugTag;
  }
  /**
   * Die Methode produceFlightString generiert eine eindeutige Zeichenkette
   * fr alle Flge
   */
   public String produziereFlugString (FlugInfo flugObjekt);
	String FlugString =
          obj.flightID+"-"+obj.originCity+"-"+obj.destCity+"-"+obj.departDate+"-"+
          obj.departTime+"-xxx-xxx-xxx-"+obj.planeID;
    return FlugString;
  }
}
