package insertsuppliers;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:      Joller-Voss GmbH
 * @author J.M.Joller
 * @version 1.0
 */

import java.sql.*;

public class InsertSuppliers {
  public static void main(String args[]) {
    System.out.println("Einfgen von Daten in die Tabelle SUPPLIERS");
    String url = "jdbc:odbc:COFFEES";
    //String url = "jdbc:odbc:coffeebreak";
    Connection con;
    Statement stmt;
    String query = "select SUP_NAME, SUP_ID from SUPPLIERS";

    try {
      System.out.println("Laden der ODBC JDBC Treiber");
      Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");

    } catch(java.lang.ClassNotFoundException e) {
      System.err.print("ODBC-JDBC : ClassNotFoundException: ");
      System.err.println(e.getMessage());
    }

    try {
      System.out.println("Verbindung mit der Datenbank herstellen");
      con = DriverManager.getConnection(url,"", "");

      System.out.println("Create Statement");
      stmt = con.createStatement();

      System.out.println("Ausfhren des Statements");
      System.out.println("Daten einfgen");
      stmt.executeUpdate("INSERT INTO SUPPLIERS " +
	                 "values(49, 'Superior Coffee', '1 Party Place', " +
                          "'Mendocino', 'CA', '95460')");

      System.out.println("Daten einfgen");
      stmt.executeUpdate("INSERT INTO SUPPLIERS " +
                          "values(101, 'Acme, Inc.', '99 Market Street', " +
                          "'Groundsville', 'CA', '95199')");

      System.out.println("Daten einfgen");
      stmt.executeUpdate("INSERT INTO SUPPLIERS " +
	                 "values(150, 'The High Ground', '100 Coffee Lane', " +
                         "'Meadows', 'CA', '93966')");

    } catch(SQLException ex) {
      System.err.println("SQLException: " + ex.getMessage());
      System.err.flush();
    }

    try {
      System.out.println("Verbindung mit der Datenbank herstellen fr die Abfrage");
      con = DriverManager.getConnection(url,"", "");
      System.out.println("Create Statement");
      stmt = con.createStatement();

      System.out.println("Daten abfragen");
      ResultSet rs = stmt.executeQuery(query);
      System.out.println("Suppliers und deren ID Nummern:");
      String strTab;
      while (rs.next()) {
        String s = rs.getString("SUP_NAME");
        int n = rs.getInt("SUP_ID");
        strTab="";
        if (s.length()<16) strTab="\t\t\t";
        System.out.println(s + strTab + n);
      }

      System.out.println("Abschluss");
      stmt.close();
      con.close();

    } catch(SQLException ex) {
      System.err.println("SQLException: " + ex.getMessage());
    }
    /**
    * Anzeigen der mutierten Tabelle
    */
    try {
      //Statement stmt;
      System.out.println("Kaffeeanbieter: Tabelle SUPPLIERS ausgeben");
      String selectString = "SELECT * FROM SUPPLIERS";
      System.out.println("Verbindung zur Datenbank aufbauen");
      con = DriverManager.getConnection(url,"", "");
      System.out.println("SQL Statement vorbereiten");
      stmt = con.createStatement();
      selectString = "SELECT * FROM SUPPLIERS";
      ResultSet rs = stmt.executeQuery(selectString);
      System.out.println("SUP_ID\tSUP_NAME\t\tCITY\tSTREET\t\tSTATE\tZIP");
      int i=0;
      String[] strTab1={"\t\t","\t\t","\t"};
      String[] strTab2={"\t\t","\t","\t"};
      while (rs.next()) {
        int iSUP_ID = rs.getInt("SUP_ID");
	String sSUP_NAME = rs.getString("SUP_NAME");
        String sCITY = rs.getString("CITY");
        String sSTREET = rs.getString("STREET");
        String sSTATE = rs.getString("STATE");
        String sZIP = rs.getString("ZIP");
        System.out.println(iSUP_ID+ "\t"+ sSUP_NAME+ strTab1[i] +sCITY+"\t"+sSTREET+strTab2[i]+sSTATE+"\t"+sZIP);
        i++;
      }
      stmt.close();
      con.close();
    } catch(SQLException ex) {
      System.err.println("SQLException: " + ex.getMessage());
    }
  }
}

