package join;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:      Joller-Voss GmbH
 * @author J.M.Joller
 * @version 1.0
 */

import java.sql.*;

public class Join {
  public static void main(String args[]) {
    System.out.println("Abfrage der Kaffe Datenbank mit einem Join");
    String url = "jdbc:odbc:coffeebreak";
    Connection con;
    // ohne distinct werden alle Records zweimal angezeigt
    String query = "select distinct SUPPLIERS.SUP_NAME, COFFEES.COF_NAME " +
                    "from COFFEES, SUPPLIERS " +
                    "where SUPPLIERS.SUP_NAME like 'Acme, Inc.' "+
                    "and SUPPLIERS.SUP_ID = COFFEES.SUP_ID";
    Statement stmt;

    try {
      System.out.println("Treiber laden : ODBC JDBC");
      Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
    } catch(java.lang.ClassNotFoundException e) {
      System.err.print("Treiberfehler : ClassNotFoundException: ");
      System.err.println(e.getMessage());
    }

    try {
      System.out.println("Verbindung aufbauen");
      con = DriverManager.getConnection (url, "", "");
      boolean bAC = con.getAutoCommit();
      int iIL = con.getTransactionIsolation();
      boolean bRO = con.isReadOnly();
      System.out.println("System-Informationen");
      System.out.println("AutoCommit : "+bAC);
      System.out.println("TransactionIsolation : "+iIL);
      System.out.println("isReadOnly : "+bRO);
      System.out.println("Setzen von AutoCommit auf FALSE");
      con.setAutoCommit(false);
      System.out.println("Setzen von ReadOnly auf TRUE");
      con.setReadOnly(true);
      bAC = con.getAutoCommit();
      iIL = con.getTransactionIsolation();
      bRO = con.isReadOnly();
      System.out.println("System-Informationen");
      System.out.println("AutoCommit : "+bAC);
      System.out.println("TransactionIsolation : "+iIL);
      System.out.println("isReadOnly : "+bRO);
      System.out.println("Abfrage vorbereiten");
      stmt = con.createStatement();
      System.out.println("Resultset aufbauen");
      ResultSet rs = stmt.executeQuery(query);
      System.out.println("Und hier das Ergebnis:");
      System.out.println("\tSupplier \t\t Coffee:");
      while (rs.next()) {
        String supName = rs.getString(1);
        String cofName = rs.getString(2);
        System.out.println("\t" + supName + "\t\t" + cofName);
      }
      System.out.println("Das war's");
      stmt.close();
      con.close();
    } catch(SQLException ex) {
      System.err.print("[]SQLException: ");
      System.err.println(ex.getMessage());
    }
  }
}

