package locking;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:      Joller-Voss GmbH
 * @author J.M.Joller
 * @version 1.0
 */

 import java.sql.*;

public class LockingTest {
  public static void main(String args[]) {
    //Datenbank deklarieren
    String url = "jdbc:odbc:coffeebreak";
    Connection con;
    //SQL-Query
    String query = "select * from COFFEES";
    Statement stmt;
    System.out.println("Try : Class.forName - Laden des Drivers");
    try {
      //Laden des JDBC-ODBC Drivers
      Class.forName ("sun.jdbc.odbc.JdbcOdbcDriver");
    }
    catch(java.lang.ClassNotFoundException e) {
      System.err.print("ClassNotFoundException: ");
      System.err.println(e.getMessage());
    }
    System.out.println("Try : DriverManager.getConnection - Verbindung herstellen");
    try {
      //Verbindung zur Datenbank herstellen
      con = DriverManager.getConnection(url, "", "");
      //SQL-Statement kreieren und ausfhren
      stmt = con.createStatement();
      ResultSet rs = stmt.executeQuery(query);
      ResultSetMetaData rsmd = rs.getMetaData();
      //Resultset ausgeben
      int numberOfColumns = rsmd.getColumnCount();
      int rowCount = 1;
      while (rs.next()) {
        System.out.println("Zeile " + rowCount + ":  ");
        for (int i = 1; i <= numberOfColumns; i++) {
          System.out.print("   Spalte " + i + ":  ");
          System.out.println(rs.getString(i));
        }
        System.out.println("");
        rowCount++;
      }
      //Metadaten ausgeben:
      System.out.println(" ");
      System.out.println("METADATEN");
      System.out.println("ColumnCount: \t"+rsmd.getColumnCount());
      System.out.println("ColumnDisplaySize von Column 2: "+rsmd.getColumnDisplaySize(2));
      System.out.println("ColumnLabel von Column 2: "+rsmd.getColumnLabel(2));
      System.out.println("ColumnName von Column 2: "+rsmd.getColumnName(2));
      System.out.println("ColumnType von Column 2: "+rsmd.getColumnType(2));
      System.out.println("ColumnTypeName von Column 2: "+rsmd.getColumnTypeName(2));
      //TransactionLevel lesen, setzten, lesen
      System.out.println("TransactionLevel: "+con.getTransactionIsolation());
      con.setReadOnly(true);
      System.out.println("TransactionLevel: "+con.getTransactionIsolation());
      //Verbindung schliessen
      System.out.println("con.close() - Verbindung schliessen");
      con.close();
    } catch(SQLException ex) {
      System.err.println("SQLException: Verbindungsaufbau " + ex.getMessage());
    }
  }
}