package preparestatement;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:      Joller-Voss GmbH
 * @author J.M.Joller
 * @version 1.0
 */

import java.sql.*;

public class PreparedStatements  {
  public static void main(String args[]) {
    System.out.println("[PrepareStatement]: Start");
    String url = "jdbc:odbc:coffeebreak";
    Connection con;
    String query = "SELECT * FROM SUPPLIERS";
    System.out.println("[PrepareStatement]Treiber laden");
    PreparedStatement updateSales;
    String updateString = "update COFFEES " +
		      "set SALES = ? where COF_NAME like ?";
    try {
      Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
    } catch(java.lang.ClassNotFoundException e) {
      System.err.print("ClassNotFoundException: ");
      System.err.println(e.getMessage());
    }
    try {
      System.out.println("[PrepareStatement]getConnection()");
      con = DriverManager.getConnection(url, "myLogin", "myPassword");
      // Vorbereiten der Anweisung
      updateSales = con.prepareStatement(updateString);
      int [] salesForWeek = {175, 150, 60, 155, 90};
      String [] coffees = {"Colombian", "French_Roast", "Espresso",
		     "Colombian_Decaf", "French_Roast_Decaf"};
      int len = coffees.length;
      /**
       * Prepared Statement
       */
      for(int i = 0; i < len; i++) {
        updateSales.setInt(1, salesForWeek[i]);
        updateSales.setString(2, coffees[i]);
        updateSales.executeUpdate();
      }
      /**
       * Ausgabe der mutierten Tabelle
       */

      System.out.println("[PrepareStatement]executeQuery");
      PreparedStatement prepStmnt = con.prepareStatement(query);
      ResultSet rs = prepStmnt.executeQuery();
      ResultSetMetaData rsmd = rs.getMetaData();
      int numberOfColumns = rsmd.getColumnCount();
      int rowCount = 1;
      while (rs.next()) {
        System.out.println("Zeile " + rowCount + ":  ");
        for (int i = 1; i <= numberOfColumns; i++) {
          System.out.print("   Spalte " + i + ":  ");
          System.out.println(rs.getString(i));
        }
        System.out.println("");
        rowCount++;
      }
      con.close();
    } catch(SQLException ex) {
      System.err.println("SQLException: PreparedStatements werden nicht untersttzt   ");
      System.err.println(ex.getMessage());
    }
    /**
    * Anzeigen der mutierten Tabelle
    */
    try {
      Statement stmt;
      System.out.println("Aktueller Stand der Kaffeeverkaeufe");
      String selectString = "SELECT * FROM COFFEES";
      System.out.println("Verbindung zur Datenbank aufbauen");
      con = DriverManager.getConnection(url,"", "");
      System.out.println("SQL Statement vorbereiten");
      stmt = con.createStatement();
      ResultSet rs = stmt.executeQuery(selectString);
      String strTab= "";
      System.out.println("COF_NAME\t\tSUP_ID\tPRICE\tSALES\tTOTAL");
      while (rs.next()) {
        String sCOF = rs.getString("COF_NAME");
	int iSUP = rs.getInt("SUP_ID");
        float fPRICE = rs.getFloat("PRICE");
        int iSALES = rs.getInt("SALES");
        int iTOTAL = rs.getInt("TOTAL");
        strTab= "\t";
        if (sCOF.length()<15) strTab="\t\t";
        System.out.println(sCOF + strTab + iSUP+"\t"+fPRICE+"\t"+iSALES+"\t"+iTOTAL);
      }
      stmt.close();
      con.close();
    } catch(SQLException ex) {
      System.err.println("SQLException: " + ex.getMessage());
    }
  }
}

