package resultsetmetamethoden;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:      Joller-Voss GmbH
 * @author J.M.Joller
 * @version 1.0
 */


import java.sql.*;

public class ResultSetMetaDatenMethoden {

	public static void main(String args[]) {

		String url = "jdbc:odbc:coffeebreak";
		Connection con;
		Statement stmt;

		try {
			Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");

		} catch(java.lang.ClassNotFoundException e) {
			System.err.print("ClassNotFoundException: ");
			System.err.println(e.getMessage());
		}

		try {
			con = DriverManager.getConnection(url, "myLogin", "myPassword");

			stmt = con.createStatement();

			ResultSet rs = stmt.executeQuery("select * from COFFEES");
			ResultSetMetaData rsmd = rs.getMetaData();

			int numberOfColumns = rsmd.getColumnCount();
			for (int i = 1; i <= numberOfColumns; i++) {
				String colName = rsmd.getColumnName(i);
				String tableName = rsmd.getTableName(i);
				String name = rsmd.getColumnTypeName(i);
				boolean caseSen = rsmd.isCaseSensitive(i);
				boolean writable = rsmd.isWritable(i);
				System.out.println("Informationen ber Spalten: getColumnName " + colName);
				System.out.println("    Spalten in der Tabelle : getTableName " + tableName);
				System.out.println("    Spalten Typen : getColumnTypeName " + name);
				System.out.println("    Gross / Kleinschreibung sensibel:  " + caseSen);
				System.out.println("    Schreibbar:  " + writable);
				System.out.println("");
			}

			while (rs.next()) {
				for (int i = 1; i<=numberOfColumns; i++) {
					String s = rs.getString(i);
					System.out.print(s + "  ");
				}
				System.out.println("");
			}

			stmt.close();
			con.close();

		} catch(SQLException ex) {
			System.err.println("SQLException: " + ex.getMessage());
		}
	}
}

