package updatecoffees;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) J.M.Joller
 * @author J.M.Joller
 * @version 1.0
 */

import java.sql.*;

public class UpdateCoffees {

	public static void main(String args[]) {
          System.out.println("[UpdateTable]Start");
          String url = "jdbc:odbc:coffeebreak";
	  Connection con;
          Statement stmt;

	  try {
            System.out.println("Verbindung zum Driver aufbauen");
	    Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
	  } catch(java.lang.ClassNotFoundException e) {
            System.err.print("ODBC : ClassNotFoundException: ");
            System.err.println(e.getMessage());
	  }

	  try {
            System.out.println("Verbindung zur Datenbank aufbauen");
	    con = DriverManager.getConnection(url,"", "");
            System.out.println("SQL Statement vorbereiten");
	    stmt = con.createStatement();

            /**
             * Mutieren der COFFEES Tabelle, Spalte SALES
             */
            System.out.println("Mutieren der Tabelle COFFEES");
            String updateString = "UPDATE COFFEES SET SALES = 75 "+
                        	"WHERE COF_NAME LIKE 'Colombian'";
            stmt.executeUpdate(updateString);
            stmt.close();
            con.close();
	  } catch(SQLException ex) {
	    System.err.println("SQLException: " + ex.getMessage());
            System.err.flush();
	  }
          /**
           * Anzeigen der mutierten Tabelle
           */

          try {
            System.out.println("Aktueller Stand der Kaffeeverkaeufe");
            String selectString = "SELECT * FROM COFFEES";
            System.out.println("Verbindung zur Datenbank aufbauen");
	    con = DriverManager.getConnection(url,"", "");
            System.out.println("SQL Statement vorbereiten");
	    stmt = con.createStatement();
            ResultSet rs = stmt.executeQuery(selectString);
            String strTab= "";
            System.out.println("COF_NAME\t\tSUP_ID\tPRICE\tSALES\tTOTAL");
            while (rs.next()) {
	      String sCOF = rs.getString("COF_NAME");
	      int iSUP = rs.getInt("SUP_ID");
              float fPRICE = rs.getFloat("PRICE");
              int iSALES = rs.getInt("SALES");
              int iTOTAL = rs.getInt("TOTAL");
              strTab= "\t";
              if (sCOF.length()<15) strTab="\t\t";
              System.out.println(sCOF + strTab + iSUP+"\t"+fPRICE+"\t"+iSALES+"\t"+iTOTAL);
            }
            stmt.close();
            con.close();
	  } catch(SQLException ex) {
	    System.err.println("SQLException: " + ex.getMessage());
	  }
          /**
           * Einfache Auswertung
           */

          try {
            System.out.println("\n\n");
            String selectString = "SELECT COF_NAME, SALES FROM COFFEES " +
	                                 "WHERE COF_NAME LIKE 'Colombian'";

            //System.out.println("Verbindung zur Datenbank aufbauen");
	    con = DriverManager.getConnection(url,"", "");
            //System.out.println("SQL Statement vorbereiten");
	    stmt = con.createStatement();
            ResultSet rs = stmt.executeQuery(selectString);
            while (rs.next()) {
		String s = rs.getString("COF_NAME");//oder getString(1)
		int n = rs.getInt("SALES"); // oder getInt(2)
		System.out.println("In dieser Woche wurden "+n +
                                " Pfund Kaffee der Sorte " + s +
 						  " verkauft.");
            }
            System.out.println("\n");
            rs = stmt.executeQuery(selectString);
            rs.next();
            String s = rs.getString(1);
            int n = rs.getInt(2);
            System.out.println("In dieser Woche wurden "+n +
                   " Pfund Kaffee der Sorte " + s +
		  " verkauft.");
            System.out.println("\n\n");

            stmt.close();
            con.close();
	  } catch(SQLException ex) {
	    System.err.println("SQLException: " + ex.getMessage());
	  }

          System.out.println("[UpdateTable]Ende");
	}
}

